@import 'normalize.css';
@import url('https://fonts.googleapis.com/css?family=Fira+Sans&display=swap');

/* TODO: Make regions */

* {
    scrollbar-color: var(--accent) var(--dark-grey);
    scrollbar-width: thin;
}

a:hover {
    color: var(--accent);
    text-shadow: 0 0 1px var(--accent);
}
a {
    color: var(--text);
    text-decoration: none;
    border: none;
    transition-property: color;
    transition-duration: 0.3s;
    transition-timing-function: ease-out;
}
.site-main a {
    color: var(--accent);
}


.toastify {
    box-shadow: unset !important;
}
@import url('https://cdn.jsdelivr.net/npm/toastify-js/src/toastify.min.css');


/* Webkit Scrollbar Customize */
::-webkit-scrollbar {
    width: 8px;
    height: 8px;
    background: var(--midnightblue);
}
::-webkit-scrollbar-thumb {
    background: #888;
}
::-webkit-scrollbar-thumb:hover {
    background: var(--text);
}
html {
    background: var(--dark-grey);
    line-height: 1.6;
    letter-spacing: 0.06em;
    scroll-behavior: smooth;
}
body, button, input, select, textarea {
    color: var(--text);
    font-family: 'Fira Sans', sans-serif;
}
pre, code, pre tt {
    font-family: 'Fira Code', monospace;
}
pre
{
    -moz-tab-size: 4;
    -o-tab-size:   4;
    tab-size:      4;
}
pre {
    padding: 0.7em 1.1em;
    overflow: auto;
    font-size: 0.9em;
    line-height: 1.5;
    letter-spacing: normal;
    white-space: pre;
    color: #eee;
    background: var(--midnightblue);
    border-radius: 4px;
    box-shadow: var(--secondary-shadow);
}
pre code {
    padding: 0;
    margin: 0;
    background: var(--midnightblue);
}
code {
    color: #eee;
    background: var(--highlight-grey);
    border-radius: 3px;
    padding: 0 3px;
    margin: 0 4px;
    word-wrap: break-word;
    letter-spacing: normal;
}
blockquote {
    border-left: 0.25em solid;
    margin: 1em;
    padding: 0 1em;
    /* font-style: italic; */
}
blockquote cite {
    font-weight: bold;
    font-style: normal;
}
blockquote cite::before {
    content: "—— ";
}
hr {
    opacity: 0.2;
    border-width: 0 0 5px 0;
    border-style: dashed;
    background: transparent;
    width: 50%;
    margin: 1.8em auto;
}
table {
    border-collapse: collapse;
    border-spacing: 0;
    empty-cells: show;
    width: 100%;
    max-width: 100%;
}
table th, table td {
    padding: 1.5%;
    border: 1px solid;
}
table th {
    font-weight: 700;
    vertical-align: bottom;
}

iframe {
    width: 100%;
    height: 560px;
    border: none;
    overflow: hidden;
}


.section-inner {
    margin: 0 auto;
    max-width: 1200px;
    width: 93%;
}
.feather {
    width: 1em;
    height: 1em;
}
.sub-menu {
    font-size: 0.7em;
}
.desktop-only, .desktop-only-ib {
    display: none;
}
.highlight {
    position: relative;
}
.highlight pre {
    padding-right: 75px;
}
.highlight-copy-btn {
    position: absolute;
    bottom: 7px;
    right: 7px;
    border: 0;
    border-radius: 4px;
    padding: 1px;
    font-size: 0.7em;
    line-height: 1.8;
    color: #fff;
    background-color: #777;
    opacity: 0.6;
    min-width: 55px;
    text-align: center;
}
.highlight-copy-btn:hover {
    background-color: #666;
}

#site-header {
    position: fixed;
    z-index: 1;
    top: 0;
    left: calc(50% - 630px/2);
    width: 630px;
    max-width: 100vw;
    border-bottom-right-radius: 10px;
    border-bottom-left-radius: 10px;
    box-sizing: border-box;
    box-shadow: var(--primary-shadow);
    background-color: var(--light-grey);
}

.hdr-wrapper {
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding: 0.5em 0;
    font-size: 1.2rem;
}
.hdr-wrapper .site-branding {
    display: inline-block;
    margin-right: 0.8em;
    font-size: 1.2em;
}
.hdr-wrapper .site-nav {
    display: inline-block;
    font-size: 1.1em;
    opacity: 1;
}
.hdr-wrapper .site-nav .has-children {
    padding-right: 0.5em;
    border-right: 2px solid var(--highlight-grey);
}
.hdr-wrapper .site-nav .sub-menu > a {
    margin-left: 0.3em;
}
.hdr-wrapper .site-nav a {
    margin-left: 0.4em;
}
.hdr-icons {
    font-size: 1.2em;
}
.hdr-social {
    display: inline-block;
    margin-left: 0;
    margin-top: 4px;
}
.hdr-social > a {
    margin-left: 0.4em;
}
.hdr-btn {
    border: none;
    background: none;
    padding: 0;
    margin-left: 0.4em;
    cursor: pointer;
}
#menu-btn {
    display: none;
    margin-right: 1em;
    cursor: pointer;
}
#mobile-menu {
    position: fixed;
    top: 3.45em;
    left: 3.45em;
    display: none;
    padding: 0.6em 1.8em;
    z-index: 1;
    box-sizing: border-box;
    box-shadow: 1px 2px 3px 0px rgba(0, 0, 0, 0.45);
    background-color: var(--light-grey);
}
#mobile-menu ul {
    list-style: none;
    margin: 0;
    padding: 0;
    line-height: 2;
    font-size: 1.2em;
}
#site-footer {
    text-align: center;
    font-size: 0.9em;
    margin-bottom: 96px;
    margin-top: 64px;
}
#site-footer p {
    margin: 0;
}
#spotlight {
    display: flex;
    min-height: 100vh;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    max-width: 93%;
    margin: auto;
    font-size: 1.5rem;
}
#spotlight.error-404 {
    flex-direction: row;
    line-height: normal;
}
p.img-404 {
    margin: 0;
}
p.img-404 svg {
    width: 180px;
    max-width: 100%;
    height: auto;
}
.banner-404 {
    margin-left: 2em;
}
.banner-404 h1 {
    font-size: 3em;
    margin: 0.5rem 0;
}
.banner-404 p {
    margin-top: 0;
}
.banner-404 .btn-404 {
    font-size: 0.8em;
}
.banner-404 .btn-404 a {
    display: inline-block;
    border: 2px solid var(--text);
    border-radius: 5px;
    padding: 5px;
    transition-property: color, border-color;
}
.banner-404 .btn-404 a:first-child {
    margin-right: 1em;
}
.banner-404 .btn-404 a:hover {
    border-color: #fff;
}
.banner-404 .btn-404 a svg {
    margin-right: 0.5em;
}
#home-center {
    display: flex;
    flex-grow: 1;
    flex-direction: column;
    justify-content: center;
}
#home-title {
    margin: 0;
    text-align: center;
}
#home-subtitle {
    margin-top: 0;
    margin-bottom: 1.5em;
    text-align: center;
    line-height: normal;
    font-size: 0.7em;
    font-style: italic;
    opacity: 0.9;
}
#home-social {
    font-size: 1.4em;
    text-align: center;
    opacity: 0.8;
}
#home-social a {
    margin: 0 0.2em;
}
#home-nav {
    opacity: 0.8;
}
#home-nav a {
    display: block;
    text-align: center;
    margin-top: 0.5em;
    float: left;
    width: 50%;
}
#home-footer {
    text-align: center;
    font-size: 0.6em;
    line-height: normal;
}
#home-footer p {
    margin-top: 0;
}
.posts-group {
    display: flex;
    margin-bottom: 1.9em;
    line-height: normal;
}
.posts-group .post-year {
    padding-top: 6px;
    margin-right: 1.8em;
    font-size: 1.6em;
}
.posts-group .post-year:hover {
    text-decoration: underline;
    cursor: pointer;
}
.posts-group .posts-list {
    flex-grow: 1;
    margin: 0;
    padding: 0;
    list-style: none;
}
.posts-group .post-item {
    border-bottom: 1px var(--highlight-grey) dashed;
}
.posts-group .post-item a {
    display: flex;
    justify-content: space-between;
    align-items: baseline;
    padding: 12px 0;
}
.posts-group .post-day {
    flex-shrink: 0;
    /* margin-left: 1em; */
}
.bg-img {
    width: 100vw;
    height: 100vh;
    opacity: 0.03;
    z-index: -1;
    position: fixed;
    top: 0;
    background-attachment: fixed;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: center;
    transition: opacity 0.5s;
}
.show-bg-img {
    z-index: 100;
    opacity: 1;
    cursor: pointer;
}
.post-header {
    margin-top: 1.2em;
    line-height: normal;
}
.post-header .post-meta {
    font-size: 0.9em;
    letter-spacing: normal;
}
.post-header h1 {
    margin-top: 0.1em;
}
hr.post-end {
    width: 50%;
    margin-top: 1.6em;
    margin-bottom: 0.8em;
    margin-left: 0;
    border-style: solid;
    border-bottom-width: 4px;
}
.content {
    text-align: justify;
    text-justify: inter-ideograph;
}
.content figure {
    max-width: 100%;
    height: auto;
    margin: 0;
    text-align: center;
}
.content figure p {
    font-size: 0.8em;
    font-style: italic;
}
.content figure.left {
    float: left;
    margin-right: 1.5em;
    max-width: 50%;
}
.content figure.right {
    float: right;
    margin-left: 1.5em;
    max-width: 50%;
}
.content figure.big {
    max-width: 100vw;
}
.content img, .content video {
    display: block;
    max-width: 100%;
    height: auto;
    margin: auto;
    border-radius: 14px;
    box-shadow: var(--secondary-shadow);
}
.content ul, .content ol {
    padding: 0;
    margin-left: 1.8em;
}
.content a.anchor {
    float: left;
    margin-left: -20px;
    padding-right: 6px;
   /*box-shadow: none;
   */
    opacity: 0.8;
}
.content a.anchor:hover {
    background: none;
    color: #018574;
    opacity: 1;
}
.content a.anchor svg {
    display: inline-block;
    width: 14px;
    height: 14px;
    vertical-align: baseline;
    visibility: hidden;
}
.content a.anchor:focus svg {
    visibility: visible;
}
.content h1:hover a.anchor svg, .content h2:hover a.anchor svg, .content h3:hover a.anchor svg, .content h4:hover a.anchor svg, .content h5:hover a.anchor svg, .content h6:hover a.anchor svg {
    visibility: visible;
}
.footnotes {
    font-size: 0.85em;
}
.footnotes a {
    box-shadow: none;
    text-decoration: underline;
    transition-property: color;
}
.footnotes a:hover {
    background: transparent;
}
.footnotes a.footnote-return {
    text-decoration: none;
}
.footnotes ol {
    line-height: 1.8;
}
.footnote-ref a {
    box-shadow: none;
    text-decoration: none;
    padding: 2px;
    border-radius: 2px;
    background-color: var(--midnightblue);
}
.post-info {
    font-size: 0.8rem;
    line-height: normal;
}
.post-info p {
    margin: 0.8em 0;
}
.post-info a:hover {
    border-bottom: 1px solid #018574;
}
.post-info svg {
    margin-right: 0.8em;
}
.post-info .tag {
    margin-right: 0.5em;
}
.post-info .tag::before {
    content: "#";
}
#toc {
    position: fixed;
    left: 50%;
    top: 0;
    display: none;
}
.toc-title {
    margin-left: 1em;
    margin-bottom: 0.5em;
    font-size: 0.8em;
    font-weight: bold;
}
#TableOfContents {
    font-size: 0.8em;
}
#TableOfContents ul {
    padding-left: 1em;
    margin: 0;
}
#TableOfContents > ul {
    list-style-type: none;
}
#TableOfContents > ul ul ul {
    font-size: 0.9em;
}
#TableOfContents a:hover {
    border-bottom: #018574 1px solid;
}
.post-nav {
    display: flex;
    justify-content: space-between;
    margin-top: 1.5em;
    margin-bottom: 2.5em;
    font-size: 1.2em;
}
.post-nav a {
    flex-basis: 50%;
    flex-grow: 1;
}
.post-nav .next-post {
    text-align: left;
    padding-right: 5px;
}
.post-nav .prev-post {
    text-align: right;
    padding-left: 5px;
}
.post-nav .post-nav-label {
    font-size: 0.8em;
    opacity: 0.8;
    text-transform: uppercase;
}
.related-posts {
    padding: 0.8em;
    margin-top: 1.5em;
    font-size: 0.8rem;
    border: 3px dashed rgba(255, 255, 255, .2);
    border-radius: 5px;
}
.related-posts h2 {
    margin: 0;
    line-height: normal;
}
.related-posts ul {
    margin-top: 0.5em;
    margin-bottom: 0;
}

.floats:hover, .pride {
    background-color: var(--secondary-accent);
}
.pride, .pride, img {
    border-top-left-radius: 12px;
    border-bottom-left-radius: 12px;
}
.pride {
    width: 60px;
    height: 60px !important;
    margin-right: 10px;
    background-size: cover;
    background-position: center;
}
.pride, .pridetext {
    float: left;
}
.pridetext {
    width: calc(90% - 110px);
    height: 60px;
}
.pridetext a {
    display: table-cell !important;
    vertical-align: middle;
    height: 60px;
}
.pridedate {
    float: right;
    margin-top: calc(30px - 0.6em);
    margin-right: 10px;
}

/* #region styling of various inputs */

input[type=text], input[type=email], input[type=password], input[type=url], select, textarea {
    border-radius: 7px;
    border-color: transparent;
    background-color: var(--light-grey);
    padding: 4px;
}

input[type=text], input[type=email], input[type=password], input[type=url] {
    height: 1.2rem;
}

select {
    height: 2rem;
}

textarea {
    width: 100%;
}

/* #region switch */
.onoffswitch {
    position: relative; width: 75px;
    -webkit-user-select:none; -moz-user-select:none; -ms-user-select: none;
}
.onoffswitch-checkbox {
    position: absolute;
    opacity: 0;
    pointer-events: none;
}
.onoffswitch-label {
    display: block; overflow: hidden; cursor: pointer;
    border-radius: 20px;
}
.onoffswitch-inner {
    display: block; width: 200%; margin-left: -100%;
    transition: margin 0.3s ease-in 0s;
}
.onoffswitch-inner:before, .onoffswitch-inner:after {
    display: block; float: left; width: 50%; height: 30px; padding: 0; line-height: 30px;
    font-size: 14px; color: white; font-family: Trebuchet, Arial, sans-serif; font-weight: bold;
    box-sizing: border-box;
}
.onoffswitch-inner:before {
    content: "ON";
    padding-left: 10px;
    background-color: var(--accent); color: var(--text);
}
.onoffswitch-inner:after {
    content: "OFF";
    padding-right: 10px;
    background-color: var(--secondary-accent); color: var(--text);
    text-align: right;
}
.onoffswitch-switch {
    display: block; width: 18px; margin: 6px;
    background: var(--light-grey);
    position: absolute; top: 0; bottom: 0;
    right: 42px;
    border: 2px solid var(--light-grey); border-radius: 20px;
    transition: all 0.3s ease-in 0s; 
}
.onoffswitch-checkbox:checked + .onoffswitch-label .onoffswitch-inner {
    margin-left: 0;
}
.onoffswitch-checkbox:checked + .onoffswitch-label .onoffswitch-switch {
    right: 0px; 
}
/*#endregion switch*/

/* #endregion styling of various inputs */


@media (min-width: 800px) {
    hr.post-end {
        width: 40%;
   }
}
@media (min-width: 1300px) {
    .desktop-only, #toc.show-toc {
        display: block;
   }
    .desktop-only-ib {
        display: inline-block;
   }
    figure.left {
        margin-left: -240px;
   }
    figure.left p {
        text-align: left;
   }
    figure.right {
        margin-right: -240px;
   }
    figure.right p {
        text-align: right;
   }
    figure.big {
        width: 1200px;
        margin-left: -240px;
   }
    hr.post-end {
        width: 30%;
   }
    #toc {
        top: 13em;
        margin-left: 370px;
        max-width: 220px;
   }
}
@media (min-width: 1800px) {
    .section-inner {
        max-width: 1600px;
   }
    figure.left {
        max-width: 75%;
        margin-left: -320px;
   }
    figure.right {
        max-width: 75%;
        margin-right: -320px;
   }
    figure.big {
        width: 1600px;
        margin-left: -320px;
   }
    hr.post-end {
        width: 30%;
   }
    #toc {
        top: 15em;
        margin-left: 490px;
        max-width: 300px;
   }
}
@media (max-width: 760px) {
    .hide-in-mobile, .site-nav.hide-in-mobile {
        display: none;
   }
    #menu-btn {
        display: inline-block;
   }
    .posts-group {
        display: block;
   }
    .posts-group .post-year {
        margin: -6px 0 4px;
   }
    #spotlight.error-404 {
        flex-direction: column;
        text-align: center;
   }
    #spotlight.error-404 .banner-404 {
        margin: 0;
   }
   .floatOnMobile {
       float: left;
   }
   td.floatOnMobile {
        width: 100%;
        margin-bottom: 5px;
        padding-left: 25px;
   }
}
.site-main {
    margin-top: 5em;
    background-color: var(--light-grey);
    padding: 20px 40px;
    border-radius: 20px;
    box-shadow: var(--primary-shadow);
    width: 960px;
    max-width: 100vw;
}
.floats {
    width: calc(50% - 16px);
    float: left;
    background-color: var(--light-grey);
    height: 60px;
    margin: 7px;
    border-radius: 12px;
    cursor: pointer;
    box-shadow: var(--secondary-shadow);
}

#modal {
    z-index: 10;
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: rgba(0, 0, 0, 0.45);
}

#modal img {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    border-radius: 15px;
    max-height: 90vh;
    max-width: 90vw;
    /*height: 90vh;
    width: 90vw; */
    object-fit: contain;
}

#mobile-menu {
    position: fixed;
    top: 3.25em;
    left: unset;
    right: 0;
    display: none;
    padding: 0.6em 1.8em;
    width: max-content;
}

@media only screen and (max-width: 640px) {
    .floats {
        width: calc(100vw - 80px);
        margin-left: 0;
   }
    #site-header {
        width: 100%;
        left: 0px;
        border-radius: 0px;
   }
   .site-main {
        margin: 30px 0;
        padding: 30px;
        width: calc(100% - 60px);
   }
   body {
       margin: 0;
   }

   :root {
        --primary-shadow: unset !important
   }
}